#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QSqlRecord>
#include <QSqlError>
#include <QSqlTableModel>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    // QSqlDatabase db = QSqlDatabase::addDatabase ("QSQLITE");
    // db.setDatabaseName (":memory:");
    // db.setDatabaseName ("test.sqlite");

    // dnf install qt5-qtbase-mysql
    // QSqlDatabase db = QSqlDatabase::addDatabase ("QMYSQL");

    // dnf install qt5-qtbase-postgresql
    QSqlDatabase db = QSqlDatabase::addDatabase ("QPSQL");

    db.setHostName ("kmlinux.fjfi.cvut.cz");
    db.setUserName ("culikzde");
    db.setPassword ("12345");
    db.setDatabaseName ("culikzde");

    if (! db.open ())
        this->setWindowTitle (db.lastError().text ());

    db.exec ("DROP TABLE IF EXISTS colors");
    db.exec ("CREATE TABLE colors (name TEXT, red INTEGER, green INTEGER, blue INTEGER)");
    db.exec ("CREATE TABLE lide (name TEXT)");
    // db.exec ("CREATE TABLE colors (name VARCHAR (80), red INT, green INT, blue INT)");
    this->setWindowTitle (db.lastError().text ());

    db.exec ("INSERT INTO colors (name, red, green, blue) VALUES ('blue', 0, 0, 255)");
    // this->setWindowTitle (db.lastError().text ());

    QSqlQuery insert (db);
    insert.prepare ("INSERT INTO colors (name, red, green, blue) VALUES (:name, :r, :g, :b)");

    insert.bindValue (":name", "green");
    insert.bindValue (":r", 0);
    insert.bindValue (":g", 255);
    insert.bindValue (":b", 0);

    insert.exec ();

    QSqlTableModel * model = new QSqlTableModel (this, db);
    model->setTable ("colors");
    model->select ();
    ui->tableView->setModel (model);

    QStringList list = db.tables ();
    for (QString name : list)
    {
        QTreeWidgetItem * branch = new QTreeWidgetItem;
        branch->setText (0, name);
        ui->treeWidget->addTopLevelItem (branch);

        QSqlQuery query = db.exec ("SELECT * FROM " + name);
        QSqlRecord rec = query.record ();
        for (int k = 0; k < rec.count(); k++)
        {
            QTreeWidgetItem * node = new QTreeWidgetItem;
            node->setText (0, rec.fieldName(k));
            branch->addChild (node);
        }
    }

}

MainWindow::~MainWindow()
{
    delete ui;
}
